package net.tomatentum.cutin.container;

import java.lang.reflect.Method;
import java.util.Collection;
import java.util.Optional;

import net.tomatentum.cutin.ReflectedMethod;

public interface MethodContainer<I extends Object> {

    void addMethods(ReflectedMethod<I>... methods);
    void addMethods(Object containingObject, Method... methods);
    default void addAllMethods(Object containingObject) {
        this.addMethods(containingObject, containingObject.getClass().getDeclaredMethods());
    };

    Collection<ReflectedMethod<I>> methods();
    Collection<ReflectedMethod<I>> findFor(I identifier);
    Optional<ReflectedMethod<I>> findFirstFor(I identifier);
    
}
